import sys
from sklearn import svm
from sklearn.model_selection import cross_val_score

from sklearn.ensemble import RandomForestClassifier
from sklearn.naive_bayes import GaussianNB
from sklearn.neighbors import KNeighborsClassifier


def main():
    # Training input
    fileTrain = sys.argv[1]
    fileTest = sys.argv[2]

    # Load data
    fileTrainHandler = open(fileTrain)
    dataTrain = fileTrainHandler.read().split("\n")

    fileTestHandler = open(fileTest)
    dataTest = fileTestHandler.read().split("\n")

    # Parse data into correct format
    trainX = []
    trainY = []
    fileListDataTrain = []
    for line in dataTrain:
        if line == "":
            continue
        # Remove non BoF things from input
        trainX.append(line.split(",")[5:-1])

        # Get what the value should be
        trainY.append(int(line.split(",")[-1]))

        # Save file name for later
        fileListDataTrain.append(line.split(",")[:4])

    # Test data
    testX = []
    testY = []
    fileListDataTest = []
    for line in dataTest:
        if line == "":
            continue
        # Remove non BoF things from input
        testX.append(line.split(",")[5:-1])

        # Get what the value should be
        testY.append(int(line.split(",")[-1]))

        # Save file name for later
        fileListDataTest.append(line.split(",")[:4])

    # Train SVM
    cvValue = 4
    nuValue = 0.5
    clf = svm.OneClassSVM(kernel='rbf', degree=3, nu=nuValue)
    clf.fit(trainX)

    # Cross validate
    scores = cross_val_score(clf, testX, testY, cv=cvValue,scoring="accuracy")
    print("cvValue: {} Nu:{} Accuracy: {:0.0f}\\% ($\\pm {:0.0f}\\%$)".format(cvValue, nuValue, scores.mean()*100, scores.std() * 100))

if "__main__":
    main()
